<a href="https://github.com/cropbox/Cropbox.jl"><img src="https://github.com/cropbox/Cropbox.jl/raw/main/docs/src/assets/logo.svg" alt="Cropbox" width="150"></a>

# Cropbox.jl

[![Stable Documentation](https://img.shields.io/badge/docs-stable-blue.svg)](https://cropbox.github.io/Cropbox.jl/stable/)
[![Latest Documentation](https://img.shields.io/badge/docs-dev-blue.svg)](https://cropbox.github.io/Cropbox.jl/dev/)
[![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gh/cropbox/cropbox-binder/main)

Cropbox is a declarative modeling framework specifically designed for developing crop models. The goal is to let crop modelers focus on *what* the model should look like rather than *how* the model is technically implemented under the hood.

## Talks

- [JuliaCon 2022](https://youtu.be/l43ldy_L35A) -- "Cropbox.jl: A Declarative Crop Modeling Framework"

## Examples

- 🍃 [LeafGasExchange.jl](https://github.com/cropbox/LeafGasExchange.jl) / [plants2020](https://github.com/cropbox/plants2020): coupled leaf gas-exchange model
- 🧄 [Garlic.jl](https://github.com/cropbox/Garlic.jl): garlic growth simulation model
- 🌱 [SimpleCrop.jl](https://github.com/cropbox/SimpleCrop.jl): example of DSSAT-like crop model written in Cropbox
- 🪴 [CropRootBox.jl](https://github.com/cropbox/CropRootBox.jl): example of root system architecture simulation like CRootBox

## Tutorials

- Cropbox Workshop: [2021](https://github.com/cropbox/cropbox-workshop-2021), [2022](https://github.com/cropbox/cropbox-workshop-2022) (Korean)
- [UW SEFS 508](https://github.com/uwkimlab/plant_modeling) -- "Plant Modeling" course at University of Washington
- [Cropbox Tutorial](https://github.com/cropbox/cropbox-tutorial-KSAFM2020) presented at [KSAFM](http://www.ksafm.org/en/) 2020 Workshop
